//
//
#include <MozziGuts.h>
#include <Oscil.h>
#include <tables/sin8192_int8.h>
#include <mozzi_midi.h>
#define CONTROL_RATE 64
//
//// use: Oscil <table_size, update_rate> oscilName (wavetable), look in .h file of table #included above
Oscil<SIN8192_NUM_CELLS, AUDIO_RATE> aSin1(SIN8192_DATA);

Oscil<SIN8192_NUM_CELLS, CONTROL_RATE> kVol1(SIN8192_DATA);

char v1;

void setup() {
  //Serial.begin(9600); // for Teensy 3.1, beware printout can cause glitches
  Serial.begin(9600);
  kVol1.setFreq(4.43f);
  startMozzi(CONTROL_RATE);// uses default control rate of 64
}


void updateControl() {
  //  // check if data has been sent from the computer:
  if (Serial.available()) {
    //    // read the most recent byte (which will be from 0 to 255):
    int8_t val = Serial.read();
    //    Serial.println(val);
    aSin1.setFreq(val);
  }
  //aSin1.setFreq(66);
  v1 = kVol1.next();
}



int updateAudio() {
  //  return aSin1.next(); // return an int signal centred around 0

  long asig = (long)
              aSin1.next() * 5;
  //    aSin2.next()*v2 +
  //    aSin3.next()*v3 +
  //    aSin4.next()*v4 +
  //    aSin5.next()*v5 +
  //    aSin6.next()*v6 +
  //    aSin7.next()*v7 +
  //    aSin8.next()*v8;
  asig >>= 4;
  return (int) asig;

}

void loop() {
  audioHook(); // required here
  //if (Serial.available()) {
  //  int val = Serial.read();
  //
  //  Serial.println(val,DEC);
  //  delay(100);
}
